/*
 * Programmieren fuer Physiker, SS 2023, Blatt 7, Aufgabe 17
 *
 * Permutationen in lexikographischer Ordnung generieren
 */

#include <iostream>
using namespace std ;

void swap_chars( char & c1, char & c2)
{
    char tmp = c1 ;
    c1 = c2 ;
    c2 = tmp ;
}

bool next_permutation( char wort[], int len)
{
    // suche groesstes k, so dass wort[k]<wort[k+1]
    // falls dies nicht existiert, ist das Ende erreicht.
    int k=len-2 ;
    while (k>=0)
    {
	if (wort[k]<wort[k+1]) break ;
	--k ;
    } 
    if (k<0) return false ;  
    
    // finde groesstes l, so dass wort[k]<wort[l]. existiert stets
    int l=len-1 ;
    while (wort[k]>=wort[l]) --l ;
    
    // tausche wort[k] und wort[l] 
    swap_chars( wort[k], wort[l]) ;
    
    // tausche alle Elemente ab k+1 bis Ende einschliesslich
    int t=len-1 ; // Index des letzten element
    ++k ; // fange ab k+1 an
    while (t>k)
    {
	swap_chars( wort[k], wort[t]) ;  // tausche bei Indizes t und k
	--t ; ++k ;           // und rechne neue Tauschpartner aus
    }	
    return true ;
}

int main()
{
    // Beispieldatensatz, muss sortiert vorliegen
    const int size=6 ;
    char wort[size] = {'A','E','E','F','F','K'} ;

    cout << "Generierung aller Permutationen" << endl << endl ;

    // Hauptschleife, erzeuge alle Permutationen
    int anzperm = 0 ;      // zaehle die Permutationen
    do
    {
	++anzperm ;
	cout << "Nr: " << anzperm << "  " ;
	for( int i=0; i<size; i++)
	    cout << wort[i] << " " ;
	cout << endl ;
    }
    while (next_permutation(wort, size))  ;

    cout << "Anzahl der Permutationen: " << anzperm << endl ;

    return 0 ;
}
